#ifndef MDD_IINPUT_H
#define MDD_IINPUT_H

#include "json.hpp"
#include <memory>
#include "IOutput.h"
#include "IUnique.h"
#include "IState.h"
#include "IConnector.h"

namespace mdd{
    class IInput 
        : public IUnique
        , public IState
        , public IConnector<IOutput>
    {
    public:
        virtual const json& getValue() = 0;
        virtual json& setDefaultValue() = 0;
        virtual bool verify(const json & data) = 0;
        virtual std::shared_ptr<IOutput> getConnection() = 0;
        virtual ~IInput() = default;
    };
}
#endif
